package test.logging;

import org.apache.log4j.Logger;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import test.logging.interfaces.Main;
import test.logging.logger.LoggerFactory;

public class Test {
	private static Logger logger = LoggerFactory.getLoggerByDefault(Test.class);

	private static final String CIRCLE = "●";

	private static final String BLANK = " ";

	public static void main(String[] args) {
		ApplicationContext context = new ClassPathXmlApplicationContext("logging.xml");
		Main main = (Main)context.getBean("main");
		for (int i = -1; i < 2; i++) {
			try {
				logger.info("------------------------------------------------------------");
				main.execute(i);
			} catch (Exception ex) {
				logger.fatal(new StringBuffer().append(CIRCLE).append(Test.class.getName()).append(BLANK).append(ex.getMessage())
						.toString());
			}
		}
	}
}
