package test.logging.advisor;

import java.lang.reflect.Method;

import org.apache.log4j.Logger;
import org.springframework.aop.ThrowsAdvice;

import test.logging.exception.NumberLargeException;
import test.logging.exception.NumberSmallException;

public class MainThrowsAdvice implements ThrowsAdvice {
	private Logger logger;

	private static final String TRIANGLE = "▲";

	private static final String BLANK = " ";

	private static final String SHARP = "#";

	public void afterThrowing(Method method, Object[] args, Object target, NumberSmallException ex) throws Throwable {
		this.logger.info(new StringBuffer().append(TRIANGLE).append(this.getClass().getName()).append(BLANK).append(
				"NumberSmallExceptionの発生を検知しました。").toString());
		this.logger.info(new StringBuffer().append(TRIANGLE).append(this.getClass().getName()).append(BLANK).append("例外が出た場所は").append(
				target.getClass().getName()).append(SHARP).append(method.getName()).append("です。").toString());
		this.logger.info(new StringBuffer().append(TRIANGLE).append(this.getClass().getName()).append(BLANK).append(
				"例外情報をNumberSmallExceptionのafterThrowingにて変更します。").toString());
		throw new NumberSmallException("NumberSmallExceptionですが、例外情報がafterThrowingにて変更されています。");
	}

	public void afterThrowing(Method method, Object[] args, Object target, NumberLargeException ex) throws Throwable {
		this.logger.info(new StringBuffer().append(TRIANGLE).append(this.getClass().getName()).append(BLANK).append(
				"NumberLargeExceptionの発生を検知しました。").toString());
		this.logger.info(new StringBuffer().append(TRIANGLE).append(this.getClass().getName()).append(BLANK).append("例外が出た場所は").append(
				target.getClass().getName()).append(SHARP).append(method.getName()).append("です。").toString());
		this.logger.info(new StringBuffer().append(TRIANGLE).append(this.getClass().getName()).append(BLANK).append(
				"例外情報をNumberLargeExceptionのafterThrowingにて変更します。").toString());
		throw new NumberLargeException("NumberLargeExceptionですが、例外情報がafterThrowingにて変更されています。");
	}

	public Logger getLogger() {
		return logger;
	}

	public void setLogger(Logger logger) {
		this.logger = logger;
	}
}
