package test.logging.interceptor;

import org.aopalliance.intercept.MethodInterceptor;
import org.aopalliance.intercept.MethodInvocation;
import org.apache.log4j.Logger;

public class LoggingInterceptor implements MethodInterceptor {
	private Logger logger;

	private static final String STAR = "★";

	private static final String SHARP = "#";

	private static final String BLANK = " ";

	public Object invoke(MethodInvocation invocation) throws Throwable {
		String className = invocation.getThis().getClass().getName();
		String methodName = invocation.getMethod().getName();

		StringBuffer buf = new StringBuffer();
		buf.append(className).append(SHARP).append(methodName);
		this.logger.info(new StringBuffer().append(STAR).append(this.getClass().getName()).append(BLANK).append(className).append(SHARP)
				.append(methodName).toString());
		Object[] args = invocation.getArguments();
		this.logger.info(new StringBuffer().append(STAR).append(this.getClass().getName()).append(BLANK).append("args.length = ").append(
				args.length).toString());

		for (int i = 0; i < args.length; i++) {
			if (args[i] == null) {
				this.logger.info(new StringBuffer().append("args[").append(i).append("]=null"));
			} else {
				this.logger.info(new StringBuffer().append("args[").append(i).append("]=").append(args[i]).toString());
			}
		}

		Object result = invocation.proceed();

		this.logger.info(new StringBuffer().append(STAR).append(this.getClass().getName()).append(BLANK).append(className).append(SHARP)
				.append(methodName).append(BLANK).append("result=").append(
						(result == null || result.toString() == null) ? "null" : result.toString()));
		return result;
	}

	public Logger getLogger() {
		return logger;
	}

	public void setLogger(Logger logger) {
		this.logger = logger;
	}
}
