package test.logging.logger;

import org.apache.log4j.Logger;

@SuppressWarnings({"unchecked"})
public class LoggerFactory {
	private static final String DEFAULT_LOGGER_NAME = "default";

	private static final LoggerFactory DEFAULT_FACTORY = new LoggerFactory(DEFAULT_LOGGER_NAME);

	private String name;

	public LoggerFactory() {
		this(DEFAULT_LOGGER_NAME);
	}

	public LoggerFactory(String name) {
		this.name = name;
	}

	public LoggerFactory(Class clazz) {
		this.name = clazz.getName();
	}

	public Logger getLogger(String name) {
		return Logger.getLogger(name);
	}

	public Logger getLogger(Class clazz) {
		return Logger.getLogger(clazz.getName());
	}

	public static Logger getLoggerByDefault(String name) {
		return DEFAULT_FACTORY.getLogger(name);
	}

	public static Logger getLoggerByDefault(Class clazz) {
		return DEFAULT_FACTORY.getLogger(clazz.getName());
	}

	public String toString() {
		return new StringBuffer().append(this.toString()).append("{").append(this.name).append("}").toString();
	}
}
